<?php
// Auteur : JLuc
//
//
// - Parametrage du traitement =
//		* specification de la table destinataire pour le formulaire
//		* correspondance des champs entre formulaire et table
//		sous la forme d'une suite de couples champform1|champtable
// - Enregistrement des valeurs saisies dans la table utilisateur
// - Autres champs enregistrés dans la table utilisateur, selon paramétrage :
//     * id_auteur
//     * statut (proposé ou publié)


// Notes :
// - Pas de gestion des "modification de reponses existantes"
// - réponses multiples oui / non

// Securite
if (!defined("_ECRIRE_INC_VERSION")) return;

error_reporting(E_ERROR | E_WARNING | E_PARSE);

function traiter_table_dist($args, $retours){
	include_spip('inc/formidable');
    include_spip ("inc/formitable");
	include_spip('base/abstract_sql');
	$options = $args['options'];
	$formulaire = $args['formulaire'];
	$id_formulaire = intval($formulaire['id_formulaire']); // quasi inutile
	$saisies = unserialize($formulaire['saisies']);
	$saisies = saisies_lister_par_nom($saisies);


    $table_destinataire = $options['table_destinataire'];
   	$correspondance_champs_formulaire_table = $options['correspondance_champs_formulaire_table'];
   	$correspondance_champs_formulaire_table = saisies_chaine2tableau($correspondance_champs_formulaire_table);

    spip_log ("========" ,'formitable');
    spip_log ("Traitement table pour formulaire $id_formulaire sur table ".$table_destinataire ,'formitable');
    spip_log (print_r($_REQUEST, 1), "formitable");

	// La personne a-t-elle un compte ?
	global $auteur_session;
	$id_auteur = $auteur_session ? intval($auteur_session['id_auteur']) : 0;

    // les champs "utilisateus" à insérer
    $inserer = false;

    // tous les champs à insérer, y compris les champs techniques
    $insertions = array();

    foreach ($correspondance_champs_formulaire_table as $nom_input => $champ_table) {
        $inserer_champ = false;

        // cas : input du formulaire => champ de la table
        if (($valeur = _request($nom_input)) !== null) {
            $inserer_champ = $inserer = true;
            spip_log ("correspondance de $nom_input avec $champ_table valeur =".$valeur, "formitable");
        }
        // cas : composition d'input => champ de la table
        // les inputs sont séparés par un +; l'ordre est significatif
        elseif (strpos($nom_input,'+')) {
            spip_log ("champ composé détecté : $nom_input avec $champ_table", "formitable");
            $compo = explode('+',$nom_input);
            $valeur = array();
            $i=0;
            foreach ($compo as $elt_compo) {
                $valeur[$i++]=$valeur[$elt_compo]=_request($elt_compo);
                if ($valeur[$elt_compo] !== null)
                    $inserer_champ = $inserer = true;
                spip_log ("dans champ composé : $elt_compo => ". $valeur[$elt_compo],"formitable");
            }
        } else spip_log ("ERREUR WEBMASTER ? Impossible d'enregistrer $nom_input", "formitable");

        if ($inserer_champ) {
            if (function_exists($f = 'traitement_champ_'.$table_destinataire.'_'.$champ_table)
                OR function_exists($f = 'traitement_champ_'.$champ_table)
                OR function_exists($f = 'traitement_champ'))
                $valeur = $f($valeur, $table_destinataire, $champ_table, $nom_input);

            // ces tableaux peuvent venir d'un input tableau ou d'une composition d'input sans traitement dédié
            $insertions[$champ_table] = (is_array($valeur) ? serialize($valeur) : $valeur);
        }
    }

    // Si la moderation est a posteriori ou que la personne a les autorisations nécessaire, on publie direct
    if ($options['champ_statut']) {
        if ($options['moderation'] == 'posteriori' or autoriser('instituer', $table_destinataire, 'unused', null, array('id_formulaire'=>$id_formulaire, 'nouveau_statut'=>'publie')))
       		$statut='publie';
       	else
       		$statut = 'prop';
        $insertions[$options['champ_statut']]=$statut;
    }

    if ($options['champ_id_auteur']) {
        // La personne a-t-elle un compte ?
       	global $auteur_session;
       	$id_auteur = $auteur_session ? intval($auteur_session['id_auteur']) : 0;
        spip_log ("auteur = ".$id_auteur, "formitable");
        $insertions[$options['champ_id_auteur']] = $id_auteur;
    }

    if (!$options['multiple']  and $options['champ_cle_primaire']
            and sql_getfetsel ( $options['champ_cle_primaire'],
                                $table_destinataire,
                                $options['champ_id_auteur'].'='.$id_auteur)) {
        $retours['message_erreur'] .= "\n<br/>"._T('Vous avez déjà répondu. Votre nouvelle réponse ne peut être prise en compte.');
        return $retours;
    }


    // S'il y a bien des choses à modifier
    if ($inserer) {
        // On insere les nouvelles valeurs
        $id = sql_insertq ($table_destinataire, $insertions);
        if (!$id)
            $retours['message_erreur'] .= "\n<br/>Erreur : l'insertion dans la table ($table_destinataire) ne se fait pas bien.".sql_error()."<pre class='reponse_formulaire_erreur'>".print_r($insertions,1)."</pre>";
    };
	return $retours;
}

function traiter_table_update_dist($id_formulaire, $traitement, $saisies_anciennes, $saisies_nouvelles){
	// à voir
}

?>